﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;


namespace ChartTest
{
    using System.Windows.Forms.DataVisualization.Charting;
    using System.Windows.Forms.DataVisualization;



    public partial class Form1 : Form
    {
        const int AREA_COUNT = 9;

        static int[] values = new int[131072];
        static int[] changes = new int[131072];
        static int valuesize = 131072;
        static int position = 0;
        static int max = 0;
        static int aquire_once = 0;
        static int stop_aquire = 0;
        static bool b_started = false;

        int[] Old_Y = new int[8];

        delegate void SetProgessCallback(int value);
        delegate void AddPointsCallback(int Index);



        public Form1()
        {
            InitializeComponent();

            /***************************************************************************************
             * Area generieren und Einstellungen
             ***************************************************************************************/
            ChartArea AreaHelper = new ChartArea();

            AreaHelper.Name = "Data";
            AreaHelper.BackColor = Color.Black;
            AreaHelper.Position.Height = 100;
            AreaHelper.Position.Width = 100;

            /*****************************************
             * X-Achse Einstellungen
             *****************************************/
            AreaHelper.AxisX.Minimum = 1;
            AreaHelper.AxisX.LineColor = Color.Gray;

            // Hauptgitter X-Achse
            AreaHelper.AxisX.MajorGrid.Enabled = false;

            // Hilfsgitter X-Achse
            AreaHelper.AxisX.MinorGrid.Enabled = false;

            // Labels
            AreaHelper.AxisX.LabelStyle.Enabled = true;
            AreaHelper.AxisX.LabelStyle.ForeColor = Color.Gray;

            // Tick Marks
            AreaHelper.AxisX.MajorTickMark.Enabled = true;
            AreaHelper.AxisX.MajorTickMark.LineColor = Color.Gray;

            // Scollbar und Zoom
            AreaHelper.AxisX.ScrollBar.IsPositionedInside = false;
            AreaHelper.AxisX.ScaleView.Zoomable = true;

            /*****************************************
             * Y-Achse Einstellungen
             *****************************************/
            AreaHelper.AxisY.TitleFont = new Font("Arial", 10);
            AreaHelper.AxisY.TitleForeColor = Color.Gray;
            AreaHelper.AxisY.LineColor = Color.Gray;
            AreaHelper.AxisY.Maximum = 17;
            AreaHelper.AxisY.Title = " ";

            // Hauptgitter Y-Achse
            AreaHelper.AxisY.MajorGrid.Enabled = true;
            AreaHelper.AxisY.MajorGrid.LineColor = Color.Gray;
            AreaHelper.AxisY.MajorGrid.Interval = 2;
            AreaHelper.AxisY.MajorGrid.IntervalOffset = 1;
            AreaHelper.AxisY.MajorGrid.LineDashStyle = ChartDashStyle.Solid;

            // Hilfsgitter Y-Achse
            AreaHelper.AxisY.MinorGrid.Enabled = false;

            // Tick Marks
            AreaHelper.AxisY.MajorTickMark.Enabled = true;
            AreaHelper.AxisY.MajorTickMark.Interval = 2;
            AreaHelper.AxisY.MajorTickMark.IntervalOffset = 1;
            AreaHelper.AxisY.MajorTickMark.LineColor = Color.Gray;

            AreaHelper.AxisY.MinorTickMark.Enabled = false;

            // Labels
            AreaHelper.AxisY.LabelStyle.IsEndLabelVisible = false;
            AreaHelper.AxisY.LabelStyle.Interval = 1;
            AreaHelper.AxisY.LabelStyle.ForeColor = Color.Gray;
            
            // Cursor
            AreaHelper.CursorX.IsUserEnabled = true;
            AreaHelper.CursorX.IsUserSelectionEnabled = true;

            // Area zum Chart hinzufügen
            chart1.ChartAreas.Add(AreaHelper);
            
            // Y-Achse Labels
            for (int i = 0; i < 8; i++)
            {

                chart1.ChartAreas[0].AxisY.CustomLabels.Add(i * 2 + 1, i * 2 + 2, "Kanal " + (i).ToString());
            }

            /***************************************************************************************
             * Series generieren mit Daten füllen und Einstellungen
             * (nur um die Einstellungen des Charts direkt testen zu können)
             ***************************************************************************************/
            
            Random random = new Random();
            for (int i = 0; i < 8; i++)
            {
                Series SeriesHelper = new Series();

                SeriesHelper.ChartType = SeriesChartType.StepLine;
                SeriesHelper.BorderWidth = 2;
                SeriesHelper.Color = Color.Green;
                SeriesHelper.MarkerBorderWidth = 0;
                // Datenpunkte generieren
                if (i == 0)
                {
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((0) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((0) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((0) + i * 2 + 1);
                    SeriesHelper.Points.AddY((0) + i * 2 + 1);
                    SeriesHelper.Points.AddY((0) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                    SeriesHelper.Points.AddY((1) + i * 2 + 1);
                }
                else
                {
                    for (int pointIndex = 0; pointIndex < 20; pointIndex++)
                    {
                        SeriesHelper.Points.AddY((random.Next(0, 2)) + i * 2 + 1);
                    }
                }
                SeriesHelper.ChartArea = chart1.ChartAreas[0].Name;

                chart1.Series.Add(SeriesHelper);
            }


            /***************************************************************************************
             * Einstellungen Chart
             ***************************************************************************************/
            chart1.Legends[0].Enabled = false;
            chart1.BackColor = Color.Black;
            chart1.AntiAliasing = AntiAliasingStyles.None;



            /***************************************************************************************
             * nach COM Ports scannen
             ***************************************************************************************/
            cb_COMPort.Items.Clear();
            for (int i = 1; i < 10; i++)
            {
                try
                {
                    serialPort1.PortName = "COM" + i.ToString();
                    serialPort1.Open();
                    serialPort1.Close();
                    cb_COMPort.Items.Add("COM" + i.ToString());
                }
                catch
                {
                }
            }

            if (cb_COMPort.Items.Count != -1)
            {
                cb_COMPort.SelectedIndex = cb_COMPort.Items.Count - 1;
            }


            /***************************************************************************************
             * Sampleclockwerte in CB eintragen
             ***************************************************************************************/
            for (int i = 1; i < 64; i++)
            {
                if (40000 / i >= 1000)
                {
                    string value = ((double)(40000 / i) / (double)1000).ToString();
                    cb_Clock.Items.Add(value + " MHz");
                }
                else
                {
                    cb_Clock.Items.Add((40000 / i).ToString() + " KHz");
                }
            }
            cb_Clock.SelectedItem = this.cb_Clock.Items[0];

            /***************************************************************************************
             * Pretiggerbufferwerte in CB eintragen
             ***************************************************************************************/
            for (int i = 0; i < 8; i++)
            {
                cb_Pretrigger.Items.Add((12.5 * i).ToString() + " %");
            }
            cb_Pretrigger.SelectedItem = cb_Pretrigger.Items[1];

            Progress1.Maximum = valuesize;

            b_started = true;
        }

        private void btn_ShowData_Click(object sender, EventArgs e)
        {
            

            AddPoints();
        }

        private void btn_Aquire_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
            serialPort1.PortName = cb_COMPort.SelectedItem.ToString();
            try
            {
                /****************************************************************
                 * Diagramm löschen
                 ****************************************************************/
                for (int i = 0; i < 8; i++)
                {
                    chart1.Series[i].Points.Clear();
                }
                //
                serialPort1.Open();
                lbl_Status.Text = "Connected: " + serialPort1.PortName.ToString() + " " + serialPort1.BaudRate.ToString();

                for (int SeriesIndex = 0; SeriesIndex < 8; SeriesIndex++)
                {
                    chart1.Series[SeriesIndex].Points.Clear();
                }
                aquire_once = 1;
                send_command(192);
                send_command(Convert.ToByte(193 + cb_Clock.SelectedIndex));
            }
            catch
            {
                MessageBox.Show("Der gewünschte COM-Port ist nicht verfügbar");
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {

        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                while (serialPort1.BytesToRead > 0 && (aquire_once == 1))
                {
                    int Byte = serialPort1.ReadByte();
                    values[position] = Byte;
                    AddPoints(position);

                    position++;
                    SetProgessValue(position);
                    if (position > valuesize - 1 || (stop_aquire != 0 && position > stop_aquire))
                    {
                        position = 0;
                        aquire_once = 0;
                        send_command(192);
                    }
                }
                serialPort1.DiscardInBuffer();
            }
            if (max < position)
            {
                max = position;
            }
        }

        private void send_command(byte command)
        {
            byte[] to_write = new byte[1];
            to_write[0] = command;
            if (serialPort1.IsOpen)
            {
                serialPort1.Write(to_write, 0, 1);
            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                serialPort1.Close();
            }
        }

        private void AddPoints()
        {
            int[] Old_Y = new int[8];
            int[] New_Y = new int[8];

            // ProgressBar einstellen
            Progress1.Maximum = values.Count();

            /****************************************************************
             * Werte hinzufügen
             ****************************************************************/
            for (int i = 0; i < values.Count(); i++)
            {
                Progress1.Value = i;                                                                // Fortschritt anzeigen

                for (int j = 0; j < 8; j++)
                {
                    New_Y[j] = ((Convert.ToInt16(values[i]) & (0x0001 << j)) >> j) + j * 2 + 1;     // Neuen Wert holen

                    if (i == 0 || i == values.Count() - 1)
                    {
                        // falls erster oder letzter Messwert, auf jeden Fall eintragen
                        Old_Y[j] = New_Y[j];                            // bei erstem Messwert vorheriger und aktueller Messwert gleichsetzen
                        chart1.Series[j].Points.AddXY(i, New_Y[j]);     // Messwert hinzufügen
                    }
                    else
                    {
                        if (Old_Y[j] != New_Y[j])
                        {
                            // bei Pegeländerung Datenpunkt hinzufügen
                            chart1.Series[j].Points.AddXY(i, New_Y[j]);
                        }
                    }
                    Old_Y[j] = New_Y[j];
                }
            }
        }

        private void AddPoints(int Index)
        {
            if (this.chart1.InvokeRequired)
            {
                AddPointsCallback d = new AddPointsCallback(AddPoints);
                this.Invoke(d, new object[] {Index});
            }
            else
            {
                int[] New_Y = new int[8];

                /****************************************************************
                 * Werte hinzufügen
                 ****************************************************************/
                for (int j = 0; j < 8; j++)
                {
                    New_Y[j] = ((Convert.ToInt16(values[Index]) & (0x0001 << j)) >> j) + j * 2 + 1;     // Neuen Wert holen

                    if (Index == 0 || Index == values.Count() - 1)
                    {
                        // falls erster oder letzter Messwert, auf jeden Fall eintragen
                        Old_Y[j] = New_Y[j];                            // bei erstem Messwert vorheriger und aktueller Messwert gleichsetzen
                        chart1.Series[j].Points.AddXY(Index, New_Y[j]);     // Messwert hinzufügen
                    }
                    else
                    {
                        if (Old_Y[j] != New_Y[j])
                        {
                            // bei Pegeländerung Datenpunkt hinzufügen
                            chart1.Series[j].Points.AddXY(Index, New_Y[j]);
                        }
                    }
                    Old_Y[j] = New_Y[j];
                }
            }
        }

        private void SetProgessValue(int value)
        {
            if (this.InvokeRequired)
            {
                SetProgessCallback d = new SetProgessCallback(SetProgessValue);
                this.Invoke(d, new object[] { value });
            }
            else
            {
                this.Progress1.Value = value;
            }
        }

        private void cb_Clock_TextChanged(object sender, EventArgs e)
        {
            if (b_started)
            {
                if (serialPort1.IsOpen)
                {
                    serialPort1.Close();
                }
                serialPort1.PortName = cb_COMPort.SelectedItem.ToString();
                try
                {
                    serialPort1.Open();
                    lbl_Status.Text = "Connected: " + serialPort1.PortName.ToString() + " " + serialPort1.BaudRate.ToString();

                    send_command(192);
                    send_command(Convert.ToByte(64 + cb_Pretrigger.SelectedIndex));
                }
                catch
                {
                    MessageBox.Show("Der gewünschte COM-Port ist nicht verfügbar");
                }
            }
        }

        private void Trigger_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            byte fourpins = 0;

            for (double i = 0; i < 4; i++)
            {
                if (Trigger.GetSelected((int)i))
                    fourpins = Convert.ToByte(fourpins + Convert.ToByte(Math.Pow(2, 3 - i)));
            }
            send_command(Convert.ToByte(144 + fourpins));

            fourpins = 0;
            for (double i = 4; i < 8; i++)
            {
                if (Trigger.GetSelected((int)i))
                    fourpins = Convert.ToByte(fourpins + Convert.ToByte(Math.Pow(2, 3 - (i - 4))));
            }
            send_command(Convert.ToByte(128 + fourpins));
        }

        private void cb_AnalyzerBaud_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*****************************************************************************
             *  Startwerte setzen
             ****************************************************************************/
            double Start = chart1.ChartAreas[0].AxisX.ScaleView.ViewMinimum;
            if (Start == 1) Start = 10;
            double End = chart1.ChartAreas[0].AxisX.ScaleView.ViewMaximum;
            int MaxPoint = chart1.Series[0].Points.Count;
            chart1.ChartAreas[0].AxisX.CustomLabels.Clear();
            /*****************************************************************************
             *  Bitbreite ausrechnen
             ****************************************************************************/
            int Baud = Convert.ToInt32(cb_AnalyerBaud.Text.ToString());
            double BitWidth = ((double)1 / Baud) / getSampleTime();

            while (Start < End)
            {
                /*****************************************************************************
                 *  Startbit suchen
                 ****************************************************************************/
                int StartbitX = -1;
                int j = cb_Kanal.SelectedIndex;
                for (int PointIndex = (int)Start; PointIndex < (int)End; PointIndex++)
                {
                    int value = ((Convert.ToInt16(values[PointIndex]) & (0x0001 << j)) >> j);
                    if (value == 0)
                    {
                        StartbitX = PointIndex;
                        break;
                    }
                }
                /*****************************************************************************
                *  Signal auswerten (8N1)
                ****************************************************************************/
                if (StartbitX > -1)
                {
                    int Return = 0;
                    for (int i = 0; i < 8; i++)
                    {
                        int index = StartbitX + (int)(BitWidth * 0.5 + BitWidth * (i + 1));
                        if (index >= values.Length)
                        {
                            break;
                        }
                        
                        int value = ((Convert.ToInt16(values[index]) & (0x0001 << j)) >> j);
                        Return += value << i;
                    }

                    Start = StartbitX + (int)BitWidth * 10;
                    /*****************************************************************************
                     *  Label Anzeigen
                     ****************************************************************************/

                    chart1.ChartAreas[0].AxisX.CustomLabels.Add(StartbitX, Start, "0x" + string.Format("{0:X}", Return), 2, LabelMarkStyle.LineSideMark);
                    chart1.ChartAreas[0].AxisX.CustomLabels.Add(StartbitX, Start, Convert.ToChar(Return).ToString(), 1, LabelMarkStyle.LineSideMark);
                    //
                    // Erste Gehversuche mit Annotations -> sollen die Custom Labels ablösen
                    //
                    //TextAnnotation AnnoHelper = new TextAnnotation();
                    //AnnoHelper.AnchorDataPoint = chart1.Series[0].Points[5];
                    //AnnoHelper.BackColor = Color.White;
                    ////AnnoHelper.X = StartbitX;
                    ////AnnoHelper.Width = Start - StartbitX;
                    ////AnnoHelper.Y = 3;
                    //AnnoHelper.Text = Convert.ToChar(Return).ToString();
                    //AnnoHelper.Visible = true;
                    //chart1.Annotations.Add(AnnoHelper);

                }
                else
                {
                    // Startbit wurde nicht gefunden
                    Start = End;
                }
            }
        }

        private string getTimeDifference(double Start, double End)
        {
            double time = (End - Start) / ((double)40000 / (double)(cb_Clock.SelectedIndex + 1));
            string[] unit = new string[3] { "ms", "µs", "ns" };
            int i = 0;
            while (time < 1)
            {
                time *= 1000;
                i++;
            }
            return time.ToString() + unit[i];
        }

        private double getSampleTime()
        {
            return 1 / ((double)40000 / (double)(cb_Clock.SelectedIndex + 1) * 1000);
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            /****************************************************************
* Diagramm löschen
****************************************************************/
            for (int i = 0; i < 8; i++)
            {
                chart1.Series[i].Points.Clear();
            }
        }
    }



}
